package com.jiuqi.script.rhino;

package .tmp;

import com.jiuqi.script.IScriptObject;
import com.jiuqi.script.rhino.RhinoScriptObject;
import com.jiuqi.script.rhino.ScriptHelper;
import org.mozilla.javascript.Callable;
import org.mozilla.javascript.Context;
import org.mozilla.javascript.Scriptable;

class ScriptFunction implements Callable {
  private String functionName;
  
  private IScriptObject scriptObject;
  
  public ScriptFunction(String functionName, IScriptObject scriptObject) {
    this.functionName = functionName;
    this.scriptObject = scriptObject;
  }
  
  public Object call(Context cx, Scriptable scope, Scriptable thisObj, Object[] args) {
    if (args == null)
      return this.scriptObject.invoke(this.functionName, new Object[0]); 
    Object[] newArgs = new Object[args.length];
    for (int i = 0; i < args.length; i++)
      newArgs[i] = ScriptHelper._toJava(args[i], scope); 
    return this.scriptObject.invoke(this.functionName, newArgs);
  }
}
